#ifndef _H_71DF397175478BEB29386C2F04DF3F7D_EncoderDecimatedSpeed_DCPS_H_
#define _H_71DF397175478BEB29386C2F04DF3F7D_EncoderDecimatedSpeed_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EncoderDecimatedSpeed_.h"


namespace phidgets_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EncoderDecimatedSpeed_TypeSupportInterface;

            typedef EncoderDecimatedSpeed_TypeSupportInterface * EncoderDecimatedSpeed_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EncoderDecimatedSpeed_TypeSupportInterface> EncoderDecimatedSpeed_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EncoderDecimatedSpeed_TypeSupportInterface> EncoderDecimatedSpeed_TypeSupportInterface_out;


            class EncoderDecimatedSpeed_DataWriter;

            typedef EncoderDecimatedSpeed_DataWriter * EncoderDecimatedSpeed_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EncoderDecimatedSpeed_DataWriter> EncoderDecimatedSpeed_DataWriter_var;
            typedef DDS_DCPSInterface_out < EncoderDecimatedSpeed_DataWriter> EncoderDecimatedSpeed_DataWriter_out;


            class EncoderDecimatedSpeed_DataReader;

            typedef EncoderDecimatedSpeed_DataReader * EncoderDecimatedSpeed_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EncoderDecimatedSpeed_DataReader> EncoderDecimatedSpeed_DataReader_var;
            typedef DDS_DCPSInterface_out < EncoderDecimatedSpeed_DataReader> EncoderDecimatedSpeed_DataReader_out;


            class EncoderDecimatedSpeed_DataReaderView;

            typedef EncoderDecimatedSpeed_DataReaderView * EncoderDecimatedSpeed_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EncoderDecimatedSpeed_DataReaderView> EncoderDecimatedSpeed_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EncoderDecimatedSpeed_DataReaderView> EncoderDecimatedSpeed_DataReaderView_out;

            struct EncoderDecimatedSpeed_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EncoderDecimatedSpeed_, struct EncoderDecimatedSpeed_Seq_uniq_> EncoderDecimatedSpeed_Seq;
            typedef DDS_DCPSSequence_var < EncoderDecimatedSpeed_Seq> EncoderDecimatedSpeed_Seq_var;
            typedef DDS_DCPSSequence_out < EncoderDecimatedSpeed_Seq> EncoderDecimatedSpeed_Seq_out;

            class  EncoderDecimatedSpeed_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EncoderDecimatedSpeed_TypeSupportInterface_ptr _ptr_type;
                typedef EncoderDecimatedSpeed_TypeSupportInterface_var _var_type;

                static EncoderDecimatedSpeed_TypeSupportInterface_ptr _duplicate (EncoderDecimatedSpeed_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EncoderDecimatedSpeed_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EncoderDecimatedSpeed_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EncoderDecimatedSpeed_TypeSupportInterface () {};
                ~EncoderDecimatedSpeed_TypeSupportInterface () {};
            private:
                EncoderDecimatedSpeed_TypeSupportInterface (const EncoderDecimatedSpeed_TypeSupportInterface &);
                EncoderDecimatedSpeed_TypeSupportInterface & operator = (const EncoderDecimatedSpeed_TypeSupportInterface &);
            };

            class  EncoderDecimatedSpeed_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EncoderDecimatedSpeed_DataWriter_ptr _ptr_type;
                typedef EncoderDecimatedSpeed_DataWriter_var _var_type;

                static EncoderDecimatedSpeed_DataWriter_ptr _duplicate (EncoderDecimatedSpeed_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EncoderDecimatedSpeed_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EncoderDecimatedSpeed_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EncoderDecimatedSpeed_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EncoderDecimatedSpeed_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EncoderDecimatedSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EncoderDecimatedSpeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EncoderDecimatedSpeed_& instance_data) = 0;

            protected:
                EncoderDecimatedSpeed_DataWriter () {};
                ~EncoderDecimatedSpeed_DataWriter () {};
            private:
                EncoderDecimatedSpeed_DataWriter (const EncoderDecimatedSpeed_DataWriter &);
                EncoderDecimatedSpeed_DataWriter & operator = (const EncoderDecimatedSpeed_DataWriter &);
            };

            class  EncoderDecimatedSpeed_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EncoderDecimatedSpeed_DataReader_ptr _ptr_type;
                typedef EncoderDecimatedSpeed_DataReader_var _var_type;

                static EncoderDecimatedSpeed_DataReader_ptr _duplicate (EncoderDecimatedSpeed_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EncoderDecimatedSpeed_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EncoderDecimatedSpeed_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EncoderDecimatedSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EncoderDecimatedSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EncoderDecimatedSpeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EncoderDecimatedSpeed_& instance) = 0;

            protected:
                EncoderDecimatedSpeed_DataReader () {};
                ~EncoderDecimatedSpeed_DataReader () {};
            private:
                EncoderDecimatedSpeed_DataReader (const EncoderDecimatedSpeed_DataReader &);
                EncoderDecimatedSpeed_DataReader & operator = (const EncoderDecimatedSpeed_DataReader &);
            };

            class  EncoderDecimatedSpeed_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EncoderDecimatedSpeed_DataReaderView_ptr _ptr_type;
                typedef EncoderDecimatedSpeed_DataReaderView_var _var_type;

                static EncoderDecimatedSpeed_DataReaderView_ptr _duplicate (EncoderDecimatedSpeed_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EncoderDecimatedSpeed_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EncoderDecimatedSpeed_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EncoderDecimatedSpeed_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EncoderDecimatedSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EncoderDecimatedSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EncoderDecimatedSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EncoderDecimatedSpeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EncoderDecimatedSpeed_& instance) = 0;

            protected:
                EncoderDecimatedSpeed_DataReaderView () {};
                ~EncoderDecimatedSpeed_DataReaderView () {};
            private:
                EncoderDecimatedSpeed_DataReaderView (const EncoderDecimatedSpeed_DataReaderView &);
                EncoderDecimatedSpeed_DataReaderView & operator = (const EncoderDecimatedSpeed_DataReaderView &);
            };
        }

    }

}

#endif
